/***************************************************************************
                          ClientTest.cpp  -  description
                             -------------------
    begin                : Fri May 4 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU LGPL (Lesser general Public License) 
 *   as published by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/lesser.html
 *
 ***************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

int main(int argc, char *argv[])
{
	int socketFd;
	struct sockaddr_in serverAddr;
	unsigned long inaddr;
	struct hostent *hp;
	char messg[1024];
	char *host;
	short port;

	if (argc < 3) {
		printf("ClientTest host port\n\n");
		return 1;
	}

	host = argv[1];
	port = atol(argv[2]);

	memset((void *)&serverAddr, 0, sizeof(struct sockaddr_in));
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_port = htons(port);
	if ((inaddr=inet_addr(host)) != INADDR_NONE) { //First try dotted-decimal
		serverAddr.sin_addr.s_addr = inaddr;
	}
	else { //try by name
		if ((hp=gethostbyname(host))==NULL) {
			printf("Client can't find the host %s\n",host);
			return 1;
		}
		else { //Found by name!
			memcpy((void *)&serverAddr.sin_addr.s_addr, hp->h_addr, hp->h_length);
		}
	}

	if ((socketFd=socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		printf("Client can't open socket\n");
		return 1;
	}

	printf("Client try to conect to %s:%i\n",host,port);
	if (connect(socketFd, (struct sockaddr *) &serverAddr, sizeof(struct sockaddr_in)) > 0) {
		printf("Client can't connect to server\n");
	}

	int nleft, nwritten;
	char *ptr;

	sprintf(messg,"GET /test.html HTTP/1.1\r\nAccept: text/html\r\n");
	nleft = strlen(messg);
	ptr = messg;
	while (nleft > 0) {
		nwritten = write(socketFd, ptr, nleft);
		if (nwritten < 0) {
			printf("Clint write error\n");
			return 1;
		}
		nleft -= nwritten;
		ptr += nwritten;
	}

	int nread;

	nleft = 1023;
	ptr = messg;
	while (nleft > 0) {
		nread  = read(socketFd, ptr, nleft);
		if (nread < 0) {
			printf("Client read error\n");
			return 1;
		}
		else if (nread==0)  break;
		nleft -= nread;
		ptr += nread;
	}
	printf("%s\n",messg);

	close(socketFd);
	return 0;
}
