/***************************************************************************
                            HttpLog.h  -  description
                             -------------------
    begin                : Mon June 24 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU LGPL (Lesser general Public License) 
 *   as published by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/lesser.html or in the file copying.txt
 *
 ***************************************************************************/
#ifndef _HTTPLOG_H_
#define _HTTPLOG_H_

#ifdef LINUX
 #include <pthread.h>
#elif defined (WIN32)
 #ifndef _WINDOWS_H_INCLUDED_
  #define _WINDOWS_H_INCLUDED_
  #include <windows.h>
 #endif
#endif
#include <stdio.h>
#include <fstream.h>
#include <iostream.h>


#ifndef BOOL
#define BOOL int
#endif
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

class HttpLog
{
	private:
		int m_logLevel;
		char m_logName[1025];
		ofstream m_oStream;
		BOOL m_isOpen;
		int m_openDay;
#ifdef LINUX
		pthread_mutex_t m_mutex;
		pthread_mutexattr_t m_mutex_attr;
#elif defined(WIN32)
		CRITICAL_SECTION m_mutex;
#endif

		void rotateLogs();

	public:
		HttpLog();
		HttpLog(const char *logName);
		~HttpLog();
		void open(const char *logName);
		void close();
		void logWrite(const char *string);
		void logWrite(int level, const char *string);
		void setLogLevel(int level) {m_logLevel = level;};
		char *getLogName() {return m_logName;};
};//Log

#endif
